﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace Open.Controls
{
    public partial class TextBlockEditable : UserControl
    {
        public string MyText
        {
            get { return (string)GetValue(MyTextProperty); }
            set { SetValue(MyTextProperty, value); }
        }

        public static readonly DependencyProperty MyTextProperty =
            DependencyProperty.Register("MyText", typeof(string), typeof(TextBlockEditable), new PropertyMetadata("Sample String"));

        public Style MyStyle
        {
            get { return (Style)GetValue(MyStyleProperty); }
            set { SetValue(MyStyleProperty, value); }
        }

        public static readonly DependencyProperty MyStyleProperty =
            DependencyProperty.Register("MyStyle", typeof(Style), typeof(TextBlockEditable), new PropertyMetadata(null));

        public InputScope MyInputScope
        {
            get { return (InputScope)GetValue(MyInputScopeProperty); }
            set { SetValue(MyInputScopeProperty, value); }
        }

        public static readonly DependencyProperty MyInputScopeProperty =
            DependencyProperty.Register("MyInputScope", typeof(InputScope), typeof(TextBlockEditable), new PropertyMetadata(null));

        public TextBlockEditable()
        {
            InitializeComponent();
            TextBlockMain.DataContext = this;
            TextBoxMain.DataContext = this;

            TextBlockMain.MouseLeftButtonUp += new MouseButtonEventHandler(TextBlockMain_MouseLeftButtonUp);
            TextBoxMain.LostFocus += new RoutedEventHandler(TextBoxMain_LostFocus);
        }

        void TextBoxMain_LostFocus(object sender, RoutedEventArgs e)
        {
            MyText = TextBoxMain.Text;
            TextBlockMain.Visibility = Visibility.Visible;
            TextBoxMain.Visibility = Visibility.Collapsed;
        }

        void TextBlockMain_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            TextBlockMain.Visibility = Visibility.Collapsed;
            TextBoxMain.Visibility = Visibility.Visible;
            TextBoxMain.Focus();
            TextBoxMain.Select(0, TextBoxMain.Text.Length);
        }
    }
}
